
/*******************************************************************************
* Copyright (c) 2015 Olivier Langella <Olivier.Langella@moulon.inra.fr>.
*
* This file is part of XTPcpp.
*
*     XTPcpp is free software: you can redistribute it and/or modify
*     it under the terms of the GNU General Public License as published by
*     the Free Software Foundation, either version 3 of the License, or
*     (at your option) any later version.
*
*     XTPcpp is distributed in the hope that it will be useful,
*     but WITHOUT ANY WARRANTY; without even the implied warranty of
*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*     GNU General Public License for more details.
*
*     You should have received a copy of the GNU General Public License
*     along with XTPcpp.  If not, see <http://www.gnu.org/licenses/>.
*
* Contributors:
*     Olivier Langella <Olivier.Langella@moulon.inra.fr> - initial API and implementation
******************************************************************************/
#include "project.h"
#include "../input/xpipsaxhandler.h"

Project::Project()
{

}

Project::~Project()
{

}

ProjectSp Project::makeProjectSp() const {
    return std::make_shared<Project>(*this);
}


void Project::readXpipFile(QFileInfo xpip_fileinfo) {


    XpipSaxHandler * parser = new XpipSaxHandler(this);

    QXmlSimpleReader simplereader;
    simplereader.setContentHandler(parser);
    simplereader.setErrorHandler(parser);

    qDebug() << "Read XPIP XML result file '" << xpip_fileinfo.absoluteFilePath() << "'";

    QFile qfile(xpip_fileinfo.absoluteFilePath());
    QXmlInputSource xmlInputSource(&qfile);

    if (simplereader.parse(xmlInputSource)) {
    } else {
        qDebug() << parser->errorString();
        // throw PappsoException(
        //    QObject::tr("error reading tandem XML result file :\n").append(
        //         parser->errorString()));
    }
    qfile.close();

    /*
        GrpGroupingMonitor monitor;
        GrpExperiment grpExperiment(monitor);
        PeptideReader peptideReader(grpExperiment);
        FastaReader reader(peptideReader);
        reader.parse(&fastaFile);
        fastaFile.close();
        grpExperiment.startGrouping();


        std::list<GrpProteinSp> protein_list;
        grpExperiment.getGroupedProteinSpList(protein_list);
        */

}


void Project::addProteinSp(pappso::ProteinSp protein_sp) {
  _protein_list.push_back(protein_sp);
}
void Project::addMsRunIdSp(pappso::MsRunIdSp ms_run_sp) {
  _ms_run_list.push_back(ms_run_sp);
}
    std::vector<pappso::ProteinSp> & Project::getProteinList() {
      return _protein_list;
    }